%
% Status : main Dynare file
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

if isoctave || matlab_ver_less_than('8.6')
    clear all
else
    clearvars -global
    clear_persistent_variables(fileparts(which('dynare')), false)
end
tic0 = tic;
% Define global variables.
global M_ options_ oo_ estim_params_ bayestopt_ dataset_ dataset_info estimation_info ys0_ ex0_
options_ = [];
M_.fname = 'reversal_delay';
M_.dynare_version = '5.1';
oo_.dynare_version = '5.1';
options_.dynare_version = '5.1';
%
% Some global variables initialization
%
global_initialization;
M_.exo_names = cell(2,1);
M_.exo_names_tex = cell(2,1);
M_.exo_names_long = cell(2,1);
M_.exo_names(1) = {'u_nat'};
M_.exo_names_tex(1) = {'u\_nat'};
M_.exo_names_long(1) = {'u_nat'};
M_.exo_names(2) = {'ZLB_indicator'};
M_.exo_names_tex(2) = {'ZLB\_indicator'};
M_.exo_names_long(2) = {'ZLB_indicator'};
M_.endo_names = cell(7,1);
M_.endo_names_tex = cell(7,1);
M_.endo_names_long = cell(7,1);
M_.endo_names(1) = {'pi'};
M_.endo_names_tex(1) = {'pi'};
M_.endo_names_long(1) = {'pi'};
M_.endo_names(2) = {'x'};
M_.endo_names_tex(2) = {'x'};
M_.endo_names_long(2) = {'x'};
M_.endo_names(3) = {'r_nat_ann'};
M_.endo_names_tex(3) = {'r\_nat\_ann'};
M_.endo_names_long(3) = {'r_nat_ann'};
M_.endo_names(4) = {'pi_ann'};
M_.endo_names_tex(4) = {'pi\_ann'};
M_.endo_names_long(4) = {'pi_ann'};
M_.endo_names(5) = {'i_ann'};
M_.endo_names_tex(5) = {'i\_ann'};
M_.endo_names_long(5) = {'i_ann'};
M_.endo_names(6) = {'i_taylor'};
M_.endo_names_tex(6) = {'i\_taylor'};
M_.endo_names_long(6) = {'i_taylor'};
M_.endo_names(7) = {'r_nat'};
M_.endo_names_tex(7) = {'r\_nat'};
M_.endo_names_long(7) = {'r_nat'};
M_.endo_partitions = struct();
M_.param_names = cell(8,1);
M_.param_names_tex = cell(8,1);
M_.param_names_long = cell(8,1);
M_.param_names(1) = {'beta'};
M_.param_names_tex(1) = {'beta'};
M_.param_names_long(1) = {'beta'};
M_.param_names(2) = {'sigma'};
M_.param_names_tex(2) = {'sigma'};
M_.param_names_long(2) = {'sigma'};
M_.param_names(3) = {'phi_pi'};
M_.param_names_tex(3) = {'phi\_pi'};
M_.param_names_long(3) = {'phi_pi'};
M_.param_names(4) = {'phi_y'};
M_.param_names_tex(4) = {'phi\_y'};
M_.param_names_long(4) = {'phi_y'};
M_.param_names(5) = {'kappa'};
M_.param_names_tex(5) = {'kappa'};
M_.param_names_long(5) = {'kappa'};
M_.param_names(6) = {'i_fix'};
M_.param_names_tex(6) = {'i\_fix'};
M_.param_names_long(6) = {'i_fix'};
M_.param_names(7) = {'UD'};
M_.param_names_tex(7) = {'UD'};
M_.param_names_long(7) = {'UD'};
M_.param_names(8) = {'UDP'};
M_.param_names_tex(8) = {'UDP'};
M_.param_names_long(8) = {'UDP'};
M_.param_partitions = struct();
M_.exo_det_nbr = 0;
M_.exo_nbr = 2;
M_.endo_nbr = 7;
M_.param_nbr = 8;
M_.orig_endo_nbr = 7;
M_.aux_vars = [];
M_ = setup_solvers(M_);
M_.Sigma_e = zeros(2, 2);
M_.Correlation_matrix = eye(2, 2);
M_.H = 0;
M_.Correlation_matrix_ME = 1;
M_.sigma_e_is_diagonal = true;
M_.det_shocks = [];
M_.surprise_shocks = [];
M_.heteroskedastic_shocks.Qvalue_orig = [];
M_.heteroskedastic_shocks.Qscale_orig = [];
options_.linear = false;
options_.block = false;
options_.bytecode = false;
options_.use_dll = false;
M_.orig_eq_nbr = 7;
M_.eq_nbr = 7;
M_.ramsey_eq_nbr = 0;
M_.set_auxiliary_variables = exist(['./+' M_.fname '/set_auxiliary_variables.m'], 'file') == 2;
M_.epilogue_names = {};
M_.epilogue_var_list_ = {};
M_.orig_maximum_endo_lag = 1;
M_.orig_maximum_endo_lead = 1;
M_.orig_maximum_exo_lag = 0;
M_.orig_maximum_exo_lead = 0;
M_.orig_maximum_exo_det_lag = 0;
M_.orig_maximum_exo_det_lead = 0;
M_.orig_maximum_lag = 1;
M_.orig_maximum_lead = 1;
M_.orig_maximum_lag_with_diffs_expanded = 1;
M_.lead_lag_incidence = [
 1 3 10;
 0 4 11;
 0 5 0;
 0 6 0;
 0 7 0;
 0 8 0;
 2 9 0;]';
M_.nstatic = 4;
M_.nfwrd   = 1;
M_.npred   = 1;
M_.nboth   = 1;
M_.nsfwrd   = 2;
M_.nspred   = 2;
M_.ndynamic   = 3;
M_.dynamic_tmp_nbr = [0; 0; 0; 0; ];
M_.model_local_variables_dynamic_tt_idxs = {
};
M_.equations_tags = {
  1 , 'name' , '1' ;
  2 , 'name' , 'x' ;
  3 , 'name' , 'i_taylor' ;
  4 , 'name' , 'r_nat_ann' ;
  5 , 'name' , 'pi_ann' ;
  6 , 'name' , 'i_ann' ;
  7 , 'name' , 'r_nat' ;
};
M_.mapping.pi.eqidx = [1 2 3 5 ];
M_.mapping.x.eqidx = [1 2 3 ];
M_.mapping.r_nat_ann.eqidx = [4 ];
M_.mapping.pi_ann.eqidx = [5 ];
M_.mapping.i_ann.eqidx = [2 6 ];
M_.mapping.i_taylor.eqidx = [3 6 ];
M_.mapping.r_nat.eqidx = [2 3 4 7 ];
M_.mapping.u_nat.eqidx = [7 ];
M_.mapping.ZLB_indicator.eqidx = [6 ];
M_.static_and_dynamic_models_differ = false;
M_.has_external_function = false;
M_.state_var = [1 7 ];
M_.exo_names_orig_ord = [1:2];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(7, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(2, 1);
M_.params = NaN(8, 1);
M_.endo_trends = struct('deflator', cell(7, 1), 'log_deflator', cell(7, 1), 'growth_factor', cell(7, 1), 'log_growth_factor', cell(7, 1));
M_.NNZDerivatives = [23; -1; -1; ];
M_.static_tmp_nbr = [0; 0; 0; 0; ];
M_.model_local_variables_static_tt_idxs = {
};
M_.params(2) = 1;
sigma = M_.params(2);
M_.params(1) = 0.99;
beta = M_.params(1);
M_.params(5) = 0.0255;
kappa = M_.params(5);
M_.params(3) = 1.5;
phi_pi = M_.params(3);
M_.params(4) = 0.5;
phi_y = M_.params(4);
M_.params(6) = log(M_.params(1))*100;
i_fix = M_.params(6);
M_.params(7) = 0;
UD = M_.params(7);
M_.params(8) = 0;
UDP = M_.params(8);
%
% INITVAL instructions
%
options_.initval_file = false;
oo_.steady_state(7) = 1;
oo_.steady_state(6) = 1;
oo_.steady_state(5) = 4*oo_.steady_state(6);
oo_.steady_state(3) = 4*oo_.steady_state(7);
oo_.exo_steady_state(2) = 0;
if M_.exo_nbr > 0
	oo_.exo_simul = ones(M_.maximum_lag,1)*oo_.exo_steady_state';
end
if M_.exo_det_nbr > 0
	oo_.exo_det_simul = ones(M_.maximum_lag,1)*oo_.exo_det_steady_state';
end
steady;
%
% SHOCKS instructions
%
M_.det_shocks = [ M_.det_shocks;
struct('exo_det',0,'exo_id',1,'multiplicative',0,'periods',1:1,'value',(-1.5)) ];
M_.det_shocks = [ M_.det_shocks;
struct('exo_det',0,'exo_id',2,'multiplicative',0,'periods',1:8,'value',1) ];
M_.exo_det_length = 0;
options_.periods = 500;
perfect_foresight_setup;
options_.dynatol.f = 1e-15;
options_.dynatol.x = 1e-15;
options_.lmmcp.status = true;
options_.simul.maxit = 200;
perfect_foresight_solver;


oo_.time = toc(tic0);
disp(['Total computing time : ' dynsec2hms(oo_.time) ]);
if ~exist([M_.dname filesep 'Output'],'dir')
    mkdir(M_.dname,'Output');
end
save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'oo_', 'M_', 'options_');
if exist('estim_params_', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'estim_params_', '-append');
end
if exist('bayestopt_', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'bayestopt_', '-append');
end
if exist('dataset_', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'dataset_', '-append');
end
if exist('estimation_info', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'estimation_info', '-append');
end
if exist('dataset_info', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'dataset_info', '-append');
end
if exist('oo_recursive_', 'var') == 1
  save([M_.dname filesep 'Output' filesep 'reversal_delay_results.mat'], 'oo_recursive_', '-append');
end
if ~isempty(lastwarn)
  disp('Note: warning(s) encountered in MATLAB/Octave code')
end
