%
% Status : main Dynare file
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

if isoctave || matlab_ver_less_than('8.6')
    clear all
else
    clearvars -global
    clear_persistent_variables(fileparts(which('dynare')), false)
end
tic0 = tic;
% Save empty dates and dseries objects in memory.
dates('initialize');
dseries('initialize');
% Define global variables.
global M_ options_ oo_ estim_params_ bayestopt_ dataset_ dataset_info estimation_info ys0_ ex0_
options_ = [];
M_.fname = 'reversal_delay';
M_.dynare_version = '4.5.0';
oo_.dynare_version = '4.5.0';
options_.dynare_version = '4.5.0';
%
% Some global variables initialization
%
global_initialization;
diary off;
diary('reversal_delay.log');
M_.exo_names = 'u_nat';
M_.exo_names_tex = 'u\_nat';
M_.exo_names_long = 'u_nat';
M_.exo_names = char(M_.exo_names, 'ZLB_indicator');
M_.exo_names_tex = char(M_.exo_names_tex, 'ZLB\_indicator');
M_.exo_names_long = char(M_.exo_names_long, 'ZLB_indicator');
M_.endo_names = 'pi';
M_.endo_names_tex = 'pi';
M_.endo_names_long = 'pi';
M_.endo_names = char(M_.endo_names, 'x');
M_.endo_names_tex = char(M_.endo_names_tex, 'x');
M_.endo_names_long = char(M_.endo_names_long, 'x');
M_.endo_names = char(M_.endo_names, 'r_nat_ann');
M_.endo_names_tex = char(M_.endo_names_tex, 'r\_nat\_ann');
M_.endo_names_long = char(M_.endo_names_long, 'r_nat_ann');
M_.endo_names = char(M_.endo_names, 'pi_ann');
M_.endo_names_tex = char(M_.endo_names_tex, 'pi\_ann');
M_.endo_names_long = char(M_.endo_names_long, 'pi_ann');
M_.endo_names = char(M_.endo_names, 'i_ann');
M_.endo_names_tex = char(M_.endo_names_tex, 'i\_ann');
M_.endo_names_long = char(M_.endo_names_long, 'i_ann');
M_.endo_names = char(M_.endo_names, 'i_taylor');
M_.endo_names_tex = char(M_.endo_names_tex, 'i\_taylor');
M_.endo_names_long = char(M_.endo_names_long, 'i_taylor');
M_.endo_names = char(M_.endo_names, 'r_nat');
M_.endo_names_tex = char(M_.endo_names_tex, 'r\_nat');
M_.endo_names_long = char(M_.endo_names_long, 'r_nat');
M_.endo_partitions = struct();
M_.param_names = 'beta';
M_.param_names_tex = 'beta';
M_.param_names_long = 'beta';
M_.param_names = char(M_.param_names, 'sigma');
M_.param_names_tex = char(M_.param_names_tex, 'sigma');
M_.param_names_long = char(M_.param_names_long, 'sigma');
M_.param_names = char(M_.param_names, 'phi_pi');
M_.param_names_tex = char(M_.param_names_tex, 'phi\_pi');
M_.param_names_long = char(M_.param_names_long, 'phi_pi');
M_.param_names = char(M_.param_names, 'phi_y');
M_.param_names_tex = char(M_.param_names_tex, 'phi\_y');
M_.param_names_long = char(M_.param_names_long, 'phi_y');
M_.param_names = char(M_.param_names, 'kappa');
M_.param_names_tex = char(M_.param_names_tex, 'kappa');
M_.param_names_long = char(M_.param_names_long, 'kappa');
M_.param_names = char(M_.param_names, 'i_fix');
M_.param_names_tex = char(M_.param_names_tex, 'i\_fix');
M_.param_names_long = char(M_.param_names_long, 'i_fix');
M_.param_names = char(M_.param_names, 'UD');
M_.param_names_tex = char(M_.param_names_tex, 'UD');
M_.param_names_long = char(M_.param_names_long, 'UD');
M_.param_names = char(M_.param_names, 'UDP');
M_.param_names_tex = char(M_.param_names_tex, 'UDP');
M_.param_names_long = char(M_.param_names_long, 'UDP');
M_.param_partitions = struct();
M_.exo_det_nbr = 0;
M_.exo_nbr = 2;
M_.endo_nbr = 7;
M_.param_nbr = 8;
M_.orig_endo_nbr = 7;
M_.aux_vars = [];
M_.Sigma_e = zeros(2, 2);
M_.Correlation_matrix = eye(2, 2);
M_.H = 0;
M_.Correlation_matrix_ME = 1;
M_.sigma_e_is_diagonal = 1;
M_.det_shocks = [];
options_.block=0;
options_.bytecode=0;
options_.use_dll=0;
M_.hessian_eq_zero = 1;
erase_compiled_function('reversal_delay_static');
erase_compiled_function('reversal_delay_dynamic');
M_.orig_eq_nbr = 7;
M_.eq_nbr = 7;
M_.ramsey_eq_nbr = 0;
M_.lead_lag_incidence = [
 1 3 10;
 0 4 11;
 0 5 0;
 0 6 0;
 0 7 0;
 0 8 0;
 2 9 0;]';
M_.nstatic = 4;
M_.nfwrd   = 1;
M_.npred   = 1;
M_.nboth   = 1;
M_.nsfwrd   = 2;
M_.nspred   = 2;
M_.ndynamic   = 3;
M_.equations_tags = {
};
M_.static_and_dynamic_models_differ = 0;
M_.exo_names_orig_ord = [1:2];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(7, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(2, 1);
M_.params = NaN(8, 1);
M_.NNZDerivatives = [23; 0; -1];
M_.params( 2 ) = 1;
sigma = M_.params( 2 );
M_.params( 1 ) = 0.99;
beta = M_.params( 1 );
M_.params( 5 ) = 0.0255;
kappa = M_.params( 5 );
M_.params( 3 ) = 1.5;
phi_pi = M_.params( 3 );
M_.params( 4 ) = 0.5;
phi_y = M_.params( 4 );
M_.params( 6 ) = (-log(1/M_.params(1)))*100;
i_fix = M_.params( 6 );
M_.params( 7 ) = 0;
UD = M_.params( 7 );
M_.params( 8 ) = 0;
UDP = M_.params( 8 );
%
% INITVAL instructions
%
options_.initval_file = 0;
oo_.steady_state( 7 ) = 1;
oo_.steady_state( 6 ) = 1;
oo_.steady_state( 5 ) = 4*oo_.steady_state(6);
oo_.steady_state( 3 ) = 4*oo_.steady_state(7);
oo_.exo_steady_state( 2 ) = 0;
if M_.exo_nbr > 0
	oo_.exo_simul = ones(M_.maximum_lag,1)*oo_.exo_steady_state';
end
if M_.exo_det_nbr > 0
	oo_.exo_det_simul = ones(M_.maximum_lag,1)*oo_.exo_det_steady_state';
end
steady;
%
% SHOCKS instructions
%
M_.det_shocks = [ M_.det_shocks;
struct('exo_det',0,'exo_id',1,'multiplicative',0,'periods',1:1,'value',(-1.5)) ];
M_.det_shocks = [ M_.det_shocks;
struct('exo_det',0,'exo_id',2,'multiplicative',0,'periods',1:8,'value',1) ];
M_.exo_det_length = 0;
options_.periods = 500;
perfect_foresight_setup;
options_.dynatol.f = 1e-15;
options_.dynatol.x = 1e-15;
options_.lmmcp.status = 1;
options_.simul.maxit = 200;
perfect_foresight_solver;
save('reversal_delay_results.mat', 'oo_', 'M_', 'options_');
if exist('estim_params_', 'var') == 1
  save('reversal_delay_results.mat', 'estim_params_', '-append');
end
if exist('bayestopt_', 'var') == 1
  save('reversal_delay_results.mat', 'bayestopt_', '-append');
end
if exist('dataset_', 'var') == 1
  save('reversal_delay_results.mat', 'dataset_', '-append');
end
if exist('estimation_info', 'var') == 1
  save('reversal_delay_results.mat', 'estimation_info', '-append');
end
if exist('dataset_info', 'var') == 1
  save('reversal_delay_results.mat', 'dataset_info', '-append');
end
if exist('oo_recursive_', 'var') == 1
  save('reversal_delay_results.mat', 'oo_recursive_', '-append');
end


disp(['Total computing time : ' dynsec2hms(toc(tic0)) ]);
if ~isempty(lastwarn)
  disp('Note: warning(s) encountered in MATLAB/Octave code')
end
diary off
